using UnityEngine;
using UnityEngine.Events;
using System;

namespace NP
{
    public class Antimatter : MonoBehaviour
    {
        public bool active = false;
        public float active2 = 0f;
        public float active3 = 0f;
        private void Start()
        {
            var glow1 = ModAPI.CreateLight(transform, new Color(0.7f, 0f, 1f, 1f), 1f, 100f);
        }
        private void OnCollisionEnter2D(Collision2D collider2D)
        {
            if(collider2D.gameObject.name != "Antimatter Wall -NP" && collider2D.gameObject.name != "Antimatter -NP")
            {

                active = true;
                if (active2 == 0f)
                    active2 = 1f;
                collider2D.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                this.gameObject.GetComponent<Fuel>().NeutronRadius = 170f;
            }
        }
        private void FixedUpdate()
        {
            if (active == true)
            {
                GetComponent<PhysicalBehaviour>().Temperature += 2000f;
                active3++;
                var glow2 = ModAPI.CreateLight(transform, new Color(0.6f, 0.4f, 1f, 1f), 20f, 100f);
            }
            if (active2 == 1f)
            {
                active2 = 2f;
                var glow2 = ModAPI.CreateLight(transform, new Color(0.4f, 0.2f, 0.9f, 1f), 75f, 50f);
            }
            if (active3 > 50)
            {
                this.gameObject.GetOrAddComponent<ExplosiveBehaviour>().Range = 25f;
                this.gameObject.GetComponent<ExplosiveBehaviour>().Delay = 0f;
                this.gameObject.GetComponent<ExplosiveBehaviour>().ShockwaveStrength = 50f;
                this.gameObject.GetComponent<ExplosiveBehaviour>().FragmentForce = 30f;
                this.gameObject.GetComponent<ExplosiveBehaviour>().DestroyOnExplode = true;
                this.gameObject.GetComponent<ExplosiveBehaviour>().BurnPower = 1000f;
                this.gameObject.GetComponent<ExplosiveBehaviour>().ShockwaveLiftForce = 5f;
                this.gameObject.GetComponent<ExplosiveBehaviour>().DismemberChance = 100f;
                this.gameObject.GetComponent<ExplosiveBehaviour>().TemperatureLimit = -1000f;
                this.gameObject.GetComponent<ExplosiveBehaviour>().BigExplosion = true;
            }
            else if (active3 > 40)
            {
                var glow2 = ModAPI.CreateLight(transform, new Color(0.7f, 0.4f, 1f, 1f), 100f, 100f);
            }
        }
    }
}
