using UnityEngine;
using System;

namespace NP
{
    public class Boiler : MonoBehaviour
    {
        public float MultiplierBoiler = 1;
        public Liquid water = Liquid.GetLiquid("NP_WATER");
        public Liquid steam = Liquid.GetLiquid("NP_HPS");
        WaterTank child1;
        WaterTank child2;
        private int done = 5;
        private void FixedUpdate()
        {
            if (done < 1 && done > -1)
            {
                done = -100;
                child1 = GameObject.Find(this.GetComponent<CreateChild>().UniqueID[0].ToString()).GetComponent<WaterTank>();
                child2 = GameObject.Find(this.GetComponent<CreateChild>().UniqueID[1].ToString()).GetComponent<WaterTank>();
                //ModAPI.Notify("Test: " + child1.UpperLimit);
            }
            else if (done > 0)
            {
                done--;
            }
            //ModAPI.Notify("Test: " + child1.GetPercentageOf(water) * child1.UpperLimit + "/" + 2.8f * 1f * MultiplierBoiler * child1.ScaledLiquidAmount * 10 + " Total: " + child1.TotalLiquidAmount);
            if (child1.GetPercentageOf(water) * child1.UpperLimit > 2.8f * 1f * MultiplierBoiler * child1.ScaledLiquidAmount * 10f && !(child2.IsFull(0.95f)) && GetComponent<PhysicalBehaviour>().Temperature > 100f)
            {
                //ModAPI.Notify("Test: " + child1.ScaledLiquidAmount + " " + child2.ScaledLiquidAmount);
                GetComponent<PhysicalBehaviour>().Temperature -= 0.5f * MultiplierBoiler * child1.ScaledLiquidAmount * 1000f;
                child2.AddLiquid(steam, 2.8f * 1f * MultiplierBoiler * child1.ScaledLiquidAmount * 10f);
                child1.RemoveLiquid(water, 2.8f * 1f * MultiplierBoiler * child1.ScaledLiquidAmount * 10f);
            }

        }
    }
}
