using UnityEngine;
//using Random = UnityEngine.Random;
using System;
using System.Collections.Generic;

namespace NP
{
    public class CreateChild : MonoBehaviour
    {
        public SpawnableAsset[] spawnable = new SpawnableAsset[10];
        public Vector3[] offset = new Vector3[10];
        public int[] UniqueID = new int[10];

        public int size;
        public bool init = true;
        private bool done = false;
        private bool done2 = true;
        private void Start()
        {
            for (int i = 0; i < size; i++)
            {
                UniqueID[i] += 100;
                /*do
                {
                    //UniqueID[i]++;
                    UniqueID[i]+=100;
                }
                while (GameObject.Find(UniqueID[i].ToString()) == true && UniqueID[i] > -1100000000);*/
            }
        }
        private void Update()
        {

            if (init == true)
            {
                //ModAPI.Notify("Length: " + size);
                for (int i = 0; i < size; i++)
                {
                    UniqueID[i] = -1500000000;
                }
                init = false;
            }
            if (done == false && done2 == false)
            {
                for (int i = 0; i < size; i++)
                {
                    /*do
                    {
                        UniqueID[i]++;
                    }
                    while (GameObject.Find(UniqueID[i].ToString()) == true && UniqueID[i] > -1100000000);
                    UniqueID[i]--;*/
                    //ModAPI.Notify("Initialised: " + UniqueID[i].ToString());
                    if (GameObject.Find(UniqueID[i].ToString()) == false)
                    {
                        do
                        {
                            UniqueID[i] = UnityEngine.Random.Range(-1000000000, 1000000000);
                        }
                        while (GameObject.Find(UniqueID[i].ToString()) == true);
                        GameObject instance;
                        instance = UnityEngine.Object.Instantiate<GameObject>(spawnable[i].Prefab, this.transform.position, this.transform.rotation);
                        instance.AddComponent<DeregisterBehaviour>();
                        instance.AddComponent<TexturePackApplier>();
                        instance.AddComponent<AudioSourceTimeScaleBehaviour>();
                        instance.AddComponent<SerialiseInstructions>().OriginalSpawnableAsset = spawnable[i];
                        instance.AddComponent<ChildNamer>().childname = UniqueID[i];
                        instance.name = UniqueID[i].ToString();
                        //Might possibly cause unintended behaviour, use with caution
                        //instance.transform.SetParent(this.transform);
                        instance.transform.position = this.transform.position + new Vector3(offset[i].x, offset[i].y);
                        //instance.transform.localPosition = new Vector3(offset.x, offset.y);
                        instance.transform.localScale = this.transform.localScale;
                        instance.transform.localRotation = Quaternion.Euler(0.0f, 0.0f, 0.0f);
                        instance.AddComponent<FixedJoint2D>().connectedBody = this.GetComponent<Rigidbody2D>();
                        CatalogBehaviour.PerformMod(spawnable[i], instance);
                        //ModAPI.Notify("Created: " + UniqueID[i].ToString());
                        UniqueID[i] += 100;
                    }
                    else
                    {
                        GameObject childobject = GameObject.Find((UniqueID[i]).ToString());
                        do
                        {
                            UniqueID[i] += UnityEngine.Random.Range(-1000000000, 1000000000);
                        }
                        while (GameObject.Find(UniqueID[i].ToString()) == true);
                        childobject.AddComponent<FixedJoint2D>().connectedBody = this.GetComponent<Rigidbody2D>();
                        childobject.name = UniqueID[i].ToString();
                        childobject.GetOrAddComponent<ChildNamer>().childname = UniqueID[i];
                        //ModAPI.Notify("Found: " + UniqueID[i].ToString());
                    }
                }
                done = true;
            }
            if (done2 == true)
                done2 = false;
        }
    }
}
