using System;
using UnityEngine;



public class SuperCapacitor : MonoBehaviour
{
    public float Output = 300000f;
    public float Storage = 0f;
    public float StorageMultiplier = 5f * 50f; //50x for seconds
    private float Count = 0f;
    private bool Release = false;

    private void Use(ActivationPropagation activation)
    {
        if (activation.Channel == (ushort)0)
        {
            //ModAPI.Notify("I'VE BEEN USED!1");
            if(Storage >= Output * StorageMultiplier)
            {
                Release = true;
                Count = StorageMultiplier;
            }
            if (Storage < Output * StorageMultiplier)
            {
                ModAPI.Notify("Capacitor is charged: " + Storage / (Output * StorageMultiplier) * 100f + "%");
            }
        }
        if (activation.Channel == (ushort)1)
        {
            ModAPI.Notify("Capacitor is charged: " + Storage / (Output * StorageMultiplier) * 100f + "%");
        }
        if (activation.Channel == (ushort)2)
        {
            ModAPI.Notify("Capacitor is charged: " + Storage / (Output * StorageMultiplier) * 100f + "%");
        }
    }
	private void FixedUpdate()
    {
        if(Release == true && Count > 0f)
        {
            GetComponent<PhysicalBehaviour>().Charge = Output;
            Count--;
        }
        if(Count==0)
        {
            Count--;
            foreach (ushort allChannel in ActivationPropagation.AllChannels)
            {
                this.SendMessage("IsolatedActivation", (object)new ActivationPropagation((UnityEngine.Object)this.transform.root, allChannel), SendMessageOptions.DontRequireReceiver);
            }
        }
        if(Release == false)
        {
            Storage += GetComponent<PhysicalBehaviour>().Charge;
            GetComponent<PhysicalBehaviour>().Charge = 0;
        }
        if (Storage > Output * StorageMultiplier)
            Storage = Output * StorageMultiplier;
    }
}
