using UnityEngine;
using System;

namespace NP
{
    public class Turbine : MonoBehaviour
    {
        public float MaxTemperature;
        public float MultiplierTurbine;
        private void Awake()
        {
            ModAPI.Notify("This contraption uses old turbine mechanics which won't be supported anymore. Replace turbines with new liquid based cooling system.");
        }
        private void FixedUpdate()
        {
            if(GetComponent<PhysicalBehaviour>().Temperature > 100f && GetComponent<PhysicalBehaviour>().Temperature < MaxTemperature)
            {
                GetComponent<PhysicalBehaviour>().Charge = GetComponent<PhysicalBehaviour>().Temperature * MultiplierTurbine * 10f;
                GetComponent<PhysicalBehaviour>().Temperature -= GetComponent<PhysicalBehaviour>().Temperature * 0.001f;
            }
            else if(MaxTemperature > 90000f && GetComponent<PhysicalBehaviour>().Temperature > 1000000f)
            {
                GetComponent<PhysicalBehaviour>().Charge = GetComponent<PhysicalBehaviour>().Temperature * MultiplierTurbine * 0.001f;
                GetComponent<PhysicalBehaviour>().Temperature -= GetComponent<PhysicalBehaviour>().Temperature * 0.001f;
            }

        }
    }
}
