using UnityEngine;
using System;

namespace NP
{
    public class CoolingTowerNew : MonoBehaviour
    {
        public float MultiplierCoolingTower = 1;
        public float MaxThroughput = 100f;
        public float Throughput;
        public Liquid exhaustSteam = Liquid.GetLiquid("NP_EXHAUSTSTEAM");
        public Liquid water = Liquid.GetLiquid("NP_WATER");
        WaterTank child1;
        WaterTank child2;
        WaterTank child3;
        private int done = 5;
        private void FixedUpdate()
        {
            if (done < 1 && done > -1)
            {
                done = -100;
                child1 = GameObject.Find(this.GetComponent<CreateChild>().UniqueID[0].ToString()).GetComponent<WaterTank>();
                child2 = GameObject.Find(this.GetComponent<CreateChild>().UniqueID[1].ToString()).GetComponent<WaterTank>();
                child3 = GameObject.Find(this.GetComponent<CreateChild>().UniqueID[2].ToString()).GetComponent<WaterTank>();
                //ModAPI.Notify("Test: " + child1.UpperLimit);
            }
            else if (done > 0)
            {
                done--;
            }
            //ModAPI.Notify("Test: " + child1.GetAmount(steam) + "/" + 2.8f * 1f * MultiplierCoolingTower * child1.ScaledLiquidAmount + " Total: " + child1.TotalLiquidAmount);
            //ModAPI.Notify("Test: " + child2.GetAmount(exhaustSteam) * child2.UpperLimit + " " + child1.ScaledLiquidAmount);
            //GetPercentageOf and GetAmount seem to be switched around.
            if (child1.GetPercentageOf(exhaustSteam) * child1.UpperLimit > 2.8f * 1f * MultiplierCoolingTower * child1.ScaledLiquidAmount * 10f && !(child2.IsFull(0.95f)) && MaxThroughput > Throughput && child3.GetPercentageOf(water) * child3.UpperLimit > 2.8f * 1f * MultiplierCoolingTower * child3.ScaledLiquidAmount * 1f)
            {
                //ModAPI.Notify("Test: " + child1.ScaledLiquidAmount + " " + child2.ScaledLiquidAmount);
                Throughput += 2.8f * 1f * MultiplierCoolingTower * child1.ScaledLiquidAmount;
                child2.AddLiquid(water, 2.8f * 1f * MultiplierCoolingTower * child1.ScaledLiquidAmount * 10);
                child3.RemoveLiquid(water, 2.8f * 1f * MultiplierCoolingTower * child1.ScaledLiquidAmount * 1);
                child1.RemoveLiquid(exhaustSteam, 2.8f * 1f * MultiplierCoolingTower * child1.ScaledLiquidAmount * 10);
                //ModAPI.Notify("Test: " + child3.ScaledLiquidAmount);
                //ModAPI.CreateParticleEffect("Explosion", this.transform.position + new Vector3(0, 20));
            }
            //ModAPI.Notify("Throughput: " + Throughput + "/" + MaxThroughput);
            Throughput -= MaxThroughput * Time.deltaTime;
            if (Throughput < 0f)
                Throughput = 0;
        }
    }
}
