using UnityEngine;
using System;

namespace NP
{
    public class GeigerCounter : MonoBehaviour
    {
        public float Counter = 0f;
        public float CounterClick = 0f;
        public float CounterClick2 = 0f;
        public AudioSource audio;
        public AudioClip[] geigerclip;
        void Awake()
        {
            audio = gameObject.GetOrAddComponent<AudioSource>();
            audio.outputAudioMixerGroup = Global.main.SoundEffects;
            audio.gameObject.GetOrAddComponent<AudioSourceTimeScaleBehaviour>();
        }
        private void Use(ActivationPropagation activation)
        {
            if (activation.Channel == (ushort)0)
            {
                ModAPI.Notify("Current Radiation: " + Counter/1000f);
            }
        }
        private void FixedUpdate()
        {
            Counter = Counter * 0.5f;
            CounterClick += Counter / 100f;
            if (CounterClick > 1f)
            {
                CounterClick = 1f;
            }
            if(CounterClick > 0.1f)
            {
                do
                {
                    audio.PlayOneShot(geigerclip[0]);
                    CounterClick -= 0.1f;
                }
                while (CounterClick > 0f);
            }
            if(CounterClick2 > 30f)
            {
                CounterClick += UnityEngine.Random.Range(0f, 10f) * 0.01f;
                CounterClick2 = 0f;
            }
            else
            {
                CounterClick2++;
            }
        }
    }
}
