using UnityEngine;
using UnityEngine.Events;
using System;

namespace NP
{
    public class Fusion : MonoBehaviour
    {
        public LightSprite glow;
        bool FLight = false;
        public bool Ignite;
        public string FuelType = "null";
        public float FuelTime;
        private void FixedUpdate()
        {
            if (FLight == false)
            {
                glow = ModAPI.CreateLight(transform, new Color(0.7f, 0.3f, 1f, 1f), 1, 1);
                FLight = true;
            }
            if (GetComponent<PhysicalBehaviour>().Temperature > 10000000f && GetComponent<PhysicalBehaviour>().Charge > 250f && Ignite == false && FuelType != "null")
            {
                Ignite = true;
            }
            else if(Ignite == true && GetComponent<PhysicalBehaviour>().Charge > 50f)
            {

                if (FuelType == "DT" && GetComponent<PhysicalBehaviour>().Temperature < 100000000f)
                {
                    GetComponent<PhysicalBehaviour>().Temperature += 1000f;
                    GetComponent<PhysicalBehaviour>().Temperature *= 1.01f;
                    glow.Radius = 0.1f;
                    glow.Brightness = GetComponent<PhysicalBehaviour>().Temperature * 0.0001f;
                    glow.Color = new Color(0.7f, 0.3f, 1f, 1f);
                }
                else if (FuelType == "null")
                {
                    glow.Radius = 0.1f;
                    glow.Brightness = GetComponent<PhysicalBehaviour>().Temperature * 0.0001f;
                    glow.Color = new Color(0.7f, 0.2f, 0.2f, 1f);
                }
                if (FuelTime < 1)
                {
                    FuelType = "null";
                }
                FuelTime -= 0.05f;
            }
            else
            {
                Ignite = false;
                glow.Radius = 0f;
                glow.Brightness = 0;
            }
        }
        private void OnCollisionEnter2D(Collision2D collider2D)
        {
            if(FuelTime<1)
            {
                if (collider2D.gameObject.name == "DT fusion pellet -NP")
                {
                    Destroy(collider2D.gameObject);
                    FuelType = "DT";
                    FuelTime = 1000f;
                }
            }
        }
    }
}
