using UnityEngine;
using System.Collections;
using System;

namespace NP
{
    public class WarpBomb : MonoBehaviour
    {
        bool activatedBomb = false;
        private void Start()
        {
            var glow1 = ModAPI.CreateLight(transform, new Color(0.3f, 1f, 0.3f, 1f), 0.3f, 200f);
        }
        private void Use(ActivationPropagation activation)
        {
            if (activation.Channel == (ushort)0)
            {
                ModAPI.Notify("Activating the bomb.");
                this.StartCoroutine(this.Explosion());
            }
        }
        private void FixedUpdate()
        {
            if(activatedBomb)
                GetComponent<PhysicalBehaviour>().Charge = 1000000f;
        }
        protected virtual IEnumerator Explosion()
        {
            activatedBomb = true;
            yield return new WaitForSeconds(5);
            var glow2 = ModAPI.CreateLight(transform, new Color(1f, 0.4f, 0.4f, 1f), 20000f, 500f);
            yield return new WaitForSeconds(1);
            CircleCollider2D circleCollider2D = this.gameObject.AddComponent<CircleCollider2D>();
            circleCollider2D.radius = 100000f;
            circleCollider2D.isTrigger = true;
            yield return new WaitForSeconds(0.1f);
            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Atom Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, this.transform.position, this.transform.rotation);
            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Atom Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, this.transform.position, this.transform.rotation);
            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Atom Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, this.transform.position, this.transform.rotation);
            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Atom Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, this.transform.position, this.transform.rotation);
            UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Atom Bomb").Prefab.GetComponent<AtomBombBehaviour>().ExplosionPrefab, this.transform.position, this.transform.rotation);
            Destroy(this.gameObject);
        }
        private void OnTriggerEnter2D(Collider2D collider2D)
        {
            if(activatedBomb)
            Destroy(collider2D.gameObject);
        }
    }
}